Index: src/work/jacint/preflow_hl2.cc
===================================================================
--- src/work/jacint/preflow_hl2.cc	(revision 109)
+++ src/work/jacint/preflow_hl2.cc	(revision 109)
@@ -0,0 +1,65 @@
+#include <iostream>
+#include <fstream>
+
+#include <list_graph.hh>
+#include <dimacs.hh>
+#include <preflow_hl2.h>
+#include <time_measure.h>
+
+using namespace hugo;
+
+// Use a DIMACS max flow file as stdin.
+// read_dimacs_demo < dimacs_max_flow_file
+int main(int, char **) {
+  typedef ListGraph::NodeIt NodeIt;
+  typedef ListGraph::EachEdgeIt EachEdgeIt;
+
+  ListGraph G;
+  NodeIt s, t;
+  ListGraph::EdgeMap<int> cap(G);
+  readDimacsMaxFlow(std::cin, G, s, t, cap);
+
+  std::cout << "preflow_hl2 demo ..." << std::endl;
+  
+  double mintime=1000000;
+
+  for ( int i=1; i!=11; ++i ) {
+    double pre_time=currTime();
+    preflow_hl2<ListGraph, int> max_flow_test(G, s, t, cap);
+    double post_time=currTime();
+    if ( mintime > post_time-pre_time ) mintime = post_time-pre_time;
+  }
+
+  preflow_hl2<ListGraph, int> max_flow_test(G, s, t, cap);
+    
+  ListGraph::NodeMap<bool> cut(G);
+  max_flow_test.minCut(cut); 
+  int min_cut_value=0;
+  for(EachEdgeIt e=G.first<EachEdgeIt>(); e.valid(); ++e) {
+    if (cut.get(G.tail(e)) && !cut.get(G.head(e))) min_cut_value+=cap.get(e);
+  }
+
+  ListGraph::NodeMap<bool> cut1(G);
+  max_flow_test.minMinCut(cut1); 
+  int min_min_cut_value=0;
+  for(EachEdgeIt e=G.first<EachEdgeIt>(); e.valid(); ++e) {
+    if (cut.get(G.tail(e)) && !cut.get(G.head(e))) 
+      min_min_cut_value+=cap.get(e);
+  }
+
+  ListGraph::NodeMap<bool> cut2(G);
+  max_flow_test.maxMinCut(cut2); 
+  int max_min_cut_value=0;
+  for(EachEdgeIt e=G.first<EachEdgeIt>(); e.valid(); ++e) {
+    if (cut2.get(G.tail(e)) && !cut2.get(G.head(e))) 
+      max_min_cut_value+=cap.get(e);
+  }
+  
+  std::cout << "min time of 10 runs: " << mintime << " sec"<< std::endl; 
+  std::cout << "flow value: "<< max_flow_test.maxFlow() << std::endl;
+  std::cout << "min cut value: "<< min_cut_value << std::endl;
+  std::cout << "min min cut value: "<< min_min_cut_value << std::endl;
+  std::cout << "max min cut value: "<< max_min_cut_value << std::endl;
+
+  return 0;
+}
Index: src/work/jacint/preflow_hl2.h
===================================================================
--- src/work/jacint/preflow_hl2.h	(revision 105)
+++ src/work/jacint/preflow_hl2.h	(revision 109)
@@ -4,29 +4,33 @@
 by jacint. 
 Runs the highest label variant of the preflow push algorithm with 
-running time O(n^2\sqrt(m)), with the 'empty level' and with the 
-heuristic that the bound b on the active nodes is not increased 
-only when b=0, when we put b=2*n-2.
-
-'A' is a parameter for the empty_level heuristic
-
-Member functions:
-
-void run() : runs the algorithm
-
- The following functions should be used after run() was already run.
-
-T maxflow() : returns the value of a maximum flow
-
-T flowonedge(EdgeIt e) : for a fixed maximum flow x it returns x(e) 
-
-FlowMap allflow() : returns the fixed maximum flow x
-
-void mincut(CutMap& M) : sets M to the characteristic vector of a 
+running time O(n^2\sqrt(m)). 
+
+Heuristics:
+
+  gap: we iterate through the nodes for finding the nodes above 
+       the gap and under level n. So it is quite slow.
+  numb: we maintain the number of nodes in level i.
+  highest label
+  
+'A' is a parameter for the gap, we only upgrade the nodes to level n,
+  if the gap is under A*n.
+
+The constructor runs the algorithm.
+
+Members:
+
+T maxFlow() : returns the value of a maximum flow
+
+T flowOnEdge(EdgeIt e) : for a fixed maximum flow x it returns x(e) 
+
+FlowMap Flow() : returns the fixed maximum flow x
+
+void minCut(CutMap& M) : sets M to the characteristic vector of a 
      minimum cut. M should be a map of bools initialized to false.
 
-void min_mincut(CutMap& M) : sets M to the characteristic vector of the 
+void minMinCut(CutMap& M) : sets M to the characteristic vector of the 
      minimum min cut. M should be a map of bools initialized to false.
 
-void max_mincut(CutMap& M) : sets M to the characteristic vector of the 
+void maxMinCut(CutMap& M) : sets M to the characteristic vector of the 
      maximum min cut. M should be a map of bools initialized to false.
 
@@ -36,5 +40,5 @@
 #define PREFLOW_HL2_H
 
-#define A 1
+#define A .9
 
 #include <vector>
@@ -45,6 +49,6 @@
 
   template <typename Graph, typename T, 
-    typename FlowMap=typename Graph::EdgeMap<T>, typename CapMap=typename Graph::EdgeMap<T>, 
-    typename IntMap=typename Graph::NodeMap<int>, typename TMap=typename Graph::NodeMap<T> >
+    typename FlowMap=typename Graph::EdgeMap<T>, 
+    typename CapMap=typename Graph::EdgeMap<T> >
   class preflow_hl2 {
     
@@ -65,20 +69,15 @@
 
     preflow_hl2(Graph& _G, NodeIt _s, NodeIt _t, CapMap& _capacity) :
-      G(_G), s(_s), t(_t), flow(_G, 0), capacity(_capacity) { }
-
-
-    void run() {
- 
-      bool no_end=true;
+      G(_G), s(_s), t(_t), flow(_G), capacity(_capacity) { 
+
       int n=G.nodeNum(); 
       int b=n-2; 
       /*
 	b is a bound on the highest level of an active node. 
-	In the beginning it is at most n-2.
       */
 
-      IntMap level(G,n);      
-      TMap excess(G); 
-      
+      typename Graph::NodeMap<int> level(G,n);      
+      typename Graph::NodeMap<T> excess(G); 
+
       std::vector<int> numb(n);    
       /*
@@ -111,5 +110,5 @@
 	}
       }
-      
+	
       level.set(s,n);
 
@@ -128,5 +127,5 @@
 	  }
 	}
-
+      
       /* 
 	 End of preprocessing 
@@ -134,30 +133,20 @@
 
 
-
       /*
 	Push/relabel on the highest level active nodes.
-      */	
+      */
       /*While there exists an active node.*/
       while (b) { 
-	if ( stack[b].empty() ) {
-	  if ( b==1 ) {
-	    if ( !no_end ) break; 
-	    else {
-	      b=2*n-2;
-	      no_end=false;
-	    }
-	  } 
+	if ( stack[b].empty() ) { 
 	  --b;
-	} else {
-	  
-	  no_end=true;
-	  
-	  NodeIt w=stack[b].top();        //w is a highest label active node.
-	  stack[b].pop();           
-	  int lev=level.get(w);
-	  int exc=excess.get(w);
-	  int newlevel=2*n;      //In newlevel we bound the next level of w.
-	  
-	  //  if ( level.get(w) < n ) { //Nem tudom ez mukodik-e
+	  continue;
+	} 
+	
+	NodeIt w=stack[b].top();   
+	stack[b].pop();           
+	int lev=level.get(w);
+	T exc=excess.get(w);
+	int newlevel=2*n;      //In newlevel we bound the next level of w.
+	
 	  for(OutEdgeIt e=G.template first<OutEdgeIt>(w); e.valid(); ++e) {
 	    
@@ -173,7 +162,7 @@
 	      /*v becomes active.*/
 	      
-	      int cap=capacity.get(e);
-	      int flo=flow.get(e);
-	      int remcap=cap-flo;
+	      T cap=capacity.get(e);
+	      T flo=flow.get(e);
+	      T remcap=cap-flo;
 	      
 	      if ( remcap >= exc ) {       
@@ -211,5 +200,5 @@
 	      /*v becomes active.*/
 	      
-	      int flo=flow.get(e);
+	      T flo=flow.get(e);
 	      
 	      if ( flo >= exc ) { 
@@ -232,40 +221,41 @@
 	  
 	} // if w still has excess after the out edge for cycle
-	 
-	  excess.set(w, exc);
+	
+	excess.set(w, exc);
+	
+
+	
+
+	/*
+	  Relabel
+	*/
+	
+	if ( exc > 0 ) {
+	  //now 'lev' is the old level of w
+	  level.set(w,++newlevel);
 	  
-
-	  /*
-	    Relabel
-	  */
+	  if ( lev < n ) {
+	    --numb[lev];
+	    
+	    if ( !numb[lev] && lev < A*n ) {  //If the level of w gets empty. 
+	      
+	      for (EachNodeIt v=G.template first<EachNodeIt>(); v.valid() ; ++v) {
+		if (level.get(v) > lev && level.get(v) < n ) level.set(v,n);  
+	      }
+	      for (int i=lev+1 ; i!=n ; ++i) numb[i]=0; 
+	      if ( newlevel < n ) newlevel=n; 
+	    } else { 
+	      if ( newlevel < n ) ++numb[newlevel]; 
+	    }
+	  } 
 	  
-	  if ( exc > 0 ) {
-	    //now 'lev' is the old level of w
-	    level.set(w,++newlevel);
-	    
-	    if ( lev < n ) {
-	      --numb[lev];
-
-	      if ( !numb[lev] && lev < A*n ) {  //If the level of w gets empty. 
-		
-		for (EachNodeIt v=G.template first<EachNodeIt>(); v.valid() ; ++v) {
-		  if (level.get(v) > lev && level.get(v) < n ) level.set(v,n);  
-		}
-		for (int i=lev+1 ; i!=n ; ++i) numb[i]=0; 
-		if ( newlevel < n ) newlevel=n; 
-	      } else { 
-		if ( newlevel < n ) ++numb[newlevel]; 
-	      }
-	    } 
-	    
-	    stack[newlevel].push(w);
-
-	  }
-
-	} // if stack[b] is nonempty
-
+	  stack[newlevel].push(w);
+	  b=newlevel;
+	  
+	}
+	
       } // while(b)
-
-
+      
+      
       value = excess.get(t);
       /*Max flow value.*/
@@ -282,5 +272,5 @@
      */
 
-    T maxflow() {
+    T maxFlow() {
       return value;
     }
@@ -289,8 +279,9 @@
 
     /*
-      For the maximum flow x found by the algorithm, it returns the flow value on Edge e, i.e. x(e). 
+      For the maximum flow x found by the algorithm, 
+      it returns the flow value on edge e, i.e. x(e). 
     */
 
-    T flowonedge(EdgeIt e) {
+    T flowOnEdge(const EdgeIt e) {
       return flow.get(e);
     }
@@ -302,5 +293,5 @@
     */
 
-    FlowMap allflow() {
+    FlowMap Flow() {
       return flow;
     }
@@ -314,5 +305,5 @@
     
     template<typename CutMap>
-    void mincut(CutMap& M) {
+    void minCut(CutMap& M) {
     
       std::queue<NodeIt> queue;
@@ -324,5 +315,5 @@
         NodeIt w=queue.front();
 	queue.pop();
-
+	
 	for(OutEdgeIt e=G.template first<OutEdgeIt>(w) ; e.valid(); ++e) {
 	  NodeIt v=G.head(e);
@@ -339,8 +330,7 @@
 	    M.set(v, true);
 	  }
-	} 
+	}
 
       }
-
     }
 
@@ -353,5 +343,5 @@
     
     template<typename CutMap>
-    void max_mincut(CutMap& M) {
+    void maxMinCut(CutMap& M) {
     
       std::queue<NodeIt> queue;
@@ -390,6 +380,6 @@
 
     template<typename CutMap>
-    void min_mincut(CutMap& M) {
-      mincut(M);
+    void minMinCut(CutMap& M) {
+      minCut(M);
     }
 
@@ -397,5 +387,5 @@
 
   };
-}//namespace hugo
+}//namespace marci
 #endif 
 
Index: src/work/jacint/preflow_hl3.cc
===================================================================
--- src/work/jacint/preflow_hl3.cc	(revision 109)
+++ src/work/jacint/preflow_hl3.cc	(revision 109)
@@ -0,0 +1,72 @@
+#include <iostream>
+#include <fstream>
+
+#include <list_graph.hh>
+#include <dimacs.hh>
+#include <preflow_hl3.h>
+#include <time_measure.h>
+
+using namespace hugo;
+
+// Use a DIMACS max flow file as stdin.
+// read_dimacs_demo < dimacs_max_flow_file
+int main(int, char **) {
+  typedef ListGraph::NodeIt NodeIt;
+  typedef ListGraph::EachEdgeIt EachEdgeIt;
+
+  ListGraph G;
+  NodeIt s, t;
+  ListGraph::EdgeMap<int> cap(G);
+  readDimacsMaxFlow(std::cin, G, s, t, cap);
+
+  std::cout << "preflow_hl3 demo ..." << std::endl;
+  
+  double mintime=1000000;
+
+  for ( int i=1; i!=11; ++i ) {
+    double pre_time=currTime();
+    preflow_hl3<ListGraph, int> max_flow_test(G, s, t, cap);
+    double post_time=currTime();
+    if ( mintime > post_time-pre_time ) mintime = post_time-pre_time;
+  }
+
+  double pre_time=currTime();
+  preflow_hl3<ListGraph, int> max_flow_test(G, s, t, cap);
+  double post_time=currTime();
+     
+  ListGraph::NodeMap<bool> cut(G);
+  max_flow_test.minCut(cut); 
+  int min_cut_value=0;
+  for(EachEdgeIt e=G.first<EachEdgeIt>(); e.valid(); ++e) {
+    if (cut.get(G.tail(e)) && !cut.get(G.head(e))) min_cut_value+=cap.get(e);
+  }
+
+  ListGraph::NodeMap<bool> cut1(G);
+  max_flow_test.minMinCut(cut1); 
+  int min_min_cut_value=0;
+  for(EachEdgeIt e=G.first<EachEdgeIt>(); e.valid(); ++e) {
+    if (cut.get(G.tail(e)) && !cut.get(G.head(e))) 
+      min_min_cut_value+=cap.get(e);
+  }
+
+  ListGraph::NodeMap<bool> cut2(G);
+  max_flow_test.maxMinCut(cut2); 
+  int max_min_cut_value=0;
+  for(EachEdgeIt e=G.first<EachEdgeIt>(); e.valid(); ++e) {
+    if (cut2.get(G.tail(e)) && !cut2.get(G.head(e))) 
+      max_min_cut_value+=cap.get(e);
+  }
+  
+  std::cout << "min time of 10 runs: " << mintime << " sec"<< std::endl;   
+  std::cout << "phase 0: " << max_flow_test.time-pre_time 
+	    << " sec"<< std::endl; 
+  std::cout << "phase 1: " << post_time-max_flow_test.time 
+	    << " sec"<< std::endl; 
+  std::cout << "flow value: "<< max_flow_test.maxFlow() << std::endl;
+  std::cout << "min cut value: "<< min_cut_value << std::endl;
+  std::cout << "min min cut value: "<< min_min_cut_value << std::endl;
+  std::cout << "max min cut value: "<< max_min_cut_value << 
+    std::endl<< std::endl;
+
+  return 0;
+}
Index: src/work/jacint/preflow_hl3.h
===================================================================
--- src/work/jacint/preflow_hl3.h	(revision 105)
+++ src/work/jacint/preflow_hl3.h	(revision 109)
@@ -3,33 +3,29 @@
 preflow_hl3.h
 by jacint. 
-Runs the highest label variant of the preflow push algorithm with 
-running time O(n^2\sqrt(m)), with the felszippantos 'empty level' 
-and with the two-phase heuristic: if there is no active node of
-level at most n, then we go into phase 1, do a bfs
-from s, and flow the excess back to s.
-
-In phase 1 we shift everything downwards by n.
-
-'A' is a parameter for the empty_level heuristic
-
-Member functions:
-
-void run() : runs the algorithm
-
- The following functions should be used after run() was already run.
-
-T maxflow() : returns the value of a maximum flow
-
-T flowonedge(EdgeIt e) : for a fixed maximum flow x it returns x(e) 
-
-FlowMap allflow() : returns the fixed maximum flow x
-
-void mincut(CutMap& M) : sets M to the characteristic vector of a 
+
+Heuristics: 
+
+ suck gap : if there is a gap, then we put all 
+   nodes reachable from the relabelled node to level n
+ 2 phase
+ highest label
+
+The constructor runs the algorithm.
+
+Members:
+
+T maxFlow() : returns the value of a maximum flow
+
+T flowOnEdge(EdgeIt e) : for a fixed maximum flow x it returns x(e) 
+
+FlowMap Flow() : returns the fixed maximum flow x
+
+void minCut(CutMap& M) : sets M to the characteristic vector of a 
      minimum cut. M should be a map of bools initialized to false.
 
-void min_mincut(CutMap& M) : sets M to the characteristic vector of the 
+void minMinCut(CutMap& M) : sets M to the characteristic vector of the 
      minimum min cut. M should be a map of bools initialized to false.
 
-void max_mincut(CutMap& M) : sets M to the characteristic vector of the 
+void maxMinCut(CutMap& M) : sets M to the characteristic vector of the 
      maximum min cut. M should be a map of bools initialized to false.
 
@@ -38,6 +34,4 @@
 #ifndef PREFLOW_HL3_H
 #define PREFLOW_HL3_H
-
-#define A 1
 
 #include <vector>
@@ -45,9 +39,11 @@
 #include <queue>
 
+#include <time_measure.h> //for test
+
 namespace hugo {
 
   template <typename Graph, typename T, 
-    typename FlowMap=typename Graph::EdgeMap<T>, typename CapMap=typename Graph::EdgeMap<T>, 
-    typename IntMap=typename Graph::NodeMap<int>, typename TMap=typename Graph::NodeMap<T> >
+    typename FlowMap=typename Graph::EdgeMap<T>, 
+    typename CapMap=typename Graph::EdgeMap<T> >
   class preflow_hl3 {
     
@@ -67,10 +63,9 @@
   public:
 
+    double time; //for test
+
     preflow_hl3(Graph& _G, NodeIt _s, NodeIt _t, CapMap& _capacity) :
-      G(_G), s(_s), t(_t), flow(_G, 0), capacity(_capacity) { }
-
-
-    void run() {
- 
+      G(_G), s(_s), t(_t), flow(_G, 0), capacity(_capacity) {
+      
       bool phase=0;
       int n=G.nodeNum(); 
@@ -81,6 +76,6 @@
       */
 
-      IntMap level(G,n);      
-      TMap excess(G); 
+      typename Graph::NodeMap<int> level(G,n);      
+      typename Graph::NodeMap<T> excess(G); 
       
       std::vector<int> numb(n);    
@@ -149,5 +144,6 @@
 	  if ( phase ) break; 
 	  phase=1;
-
+	  time=currTime();
+	  
 	  level.set(s,0);
 
@@ -188,9 +184,9 @@
 	else {
 	  
-	  NodeIt w=stack[b].top();        //w is a highest label active node.
+	  NodeIt w=stack[b].top(); 
 	  stack[b].pop();           
 	  int lev=level.get(w);
-	  int exc=excess.get(w);
-	  int newlevel=n;                 //In newlevel we bound the next level of w.
+	  T exc=excess.get(w);
+	  int newlevel=n;          //bound on the next level of w.
 	  
 	  for(OutEdgeIt e=G.template first<OutEdgeIt>(w); e.valid(); ++e) {
@@ -207,7 +203,7 @@
 	      /*v becomes active.*/
 	      
-	      int cap=capacity.get(e);
-	      int flo=flow.get(e);
-	      int remcap=cap-flo;
+	      T cap=capacity.get(e);
+	      T flo=flow.get(e);
+	      T remcap=cap-flo;
 	      
 	      if ( remcap >= exc ) {       
@@ -245,5 +241,5 @@
 	      /*v becomes active.*/
 	      
-	      int flo=flow.get(e);
+	      T flo=flow.get(e);
 	      
 	      if ( flo >= exc ) { 
@@ -350,5 +346,5 @@
      */
 
-    T maxflow() {
+    T maxFlow() {
       return value;
     }
@@ -357,8 +353,9 @@
 
     /*
-      For the maximum flow x found by the algorithm, it returns the flow value on Edge e, i.e. x(e). 
+      For the maximum flow x found by the algorithm, 
+      it returns the flow value on edge e, i.e. x(e). 
     */
 
-    T flowonedge(EdgeIt e) {
+    T flowOnEdge(EdgeIt e) {
       return flow.get(e);
     }
@@ -370,5 +367,5 @@
     */
 
-    FlowMap allflow() {
+    FlowMap Flow() {
       return flow;
     }
@@ -382,5 +379,5 @@
     
     template<typename CutMap>
-    void mincut(CutMap& M) {
+    void minCut(CutMap& M) {
     
       std::queue<NodeIt> queue;
@@ -421,5 +418,5 @@
     
     template<typename CutMap>
-    void max_mincut(CutMap& M) {
+    void maxMinCut(CutMap& M) {
     
       std::queue<NodeIt> queue;
@@ -458,6 +455,6 @@
 
     template<typename CutMap>
-    void min_mincut(CutMap& M) {
-      mincut(M);
+    void minMinCut(CutMap& M) {
+      minCut(M);
     }
 
@@ -465,5 +462,5 @@
 
   };
-}//namespace hugo
+}//namespace
 #endif 
 
Index: src/work/jacint/preflow_hl4.cc
===================================================================
--- src/work/jacint/preflow_hl4.cc	(revision 109)
+++ src/work/jacint/preflow_hl4.cc	(revision 109)
@@ -0,0 +1,76 @@
+#include <iostream>
+#include <fstream>
+
+#include <list_graph.hh>
+#include <dimacs.hh>
+#include <preflow_hl4.h>
+#include <time_measure.h>
+
+using namespace hugo;
+
+//Note, that preflow_hl4.h has a member NodeMap<bool> cut, 
+//the construction of which slowing the running time by 1-10%.
+
+// Use a DIMACS max flow file as stdin.
+// read_dimacs_demo < dimacs_max_flow_file
+int main(int, char **) {
+  typedef ListGraph::NodeIt NodeIt;
+  typedef ListGraph::EachEdgeIt EachEdgeIt;
+
+  ListGraph G;
+  NodeIt s, t;
+  ListGraph::EdgeMap<int> cap(G);
+  readDimacsMaxFlow(std::cin, G, s, t, cap);
+
+  std::cout << "preflow_hl4 demo ..." << std::endl;
+  
+  double mintime=1000000;
+
+  for ( int i=1; i!=11; ++i ) {
+    double pre_time=currTime();
+    preflow_hl4<ListGraph, int> max_flow_test(G, s, t, cap);
+    double post_time=currTime();
+    if ( mintime > post_time-pre_time ) mintime = post_time-pre_time;
+  }
+
+  double pre_time=currTime();
+  preflow_hl4<ListGraph, int> max_flow_test(G, s, t, cap);
+  double post_time=currTime();
+     
+  ListGraph::NodeMap<bool> cut(G);
+  max_flow_test.minCut(cut); 
+  int min_cut_value=0;
+  for(EachEdgeIt e=G.first<EachEdgeIt>(); e.valid(); ++e) {
+    if (cut.get(G.tail(e)) && !cut.get(G.head(e))) min_cut_value+=cap.get(e);
+  }
+
+  ListGraph::NodeMap<bool> cut1(G);
+  max_flow_test.minMinCut(cut1); 
+  int min_min_cut_value=0;
+  for(EachEdgeIt e=G.first<EachEdgeIt>(); e.valid(); ++e) {
+    if (cut.get(G.tail(e)) && !cut.get(G.head(e))) 
+      min_min_cut_value+=cap.get(e);
+  }
+
+  ListGraph::NodeMap<bool> cut2(G);
+  max_flow_test.maxMinCut(cut2); 
+  int max_min_cut_value=0;
+  for(EachEdgeIt e=G.first<EachEdgeIt>(); e.valid(); ++e) {
+    if (cut2.get(G.tail(e)) && !cut2.get(G.head(e))) 
+      max_min_cut_value+=cap.get(e);
+  }
+  
+  std::cout << "min time of 10 runs: " << mintime << " sec"<< std::endl; 
+  std::cout << "phase 0: " << max_flow_test.time-pre_time 
+	    << " sec"<< std::endl; 
+  std::cout << "phase 1: " << post_time-max_flow_test.time 
+	    << " sec"<< std::endl; 
+  std::cout << "flow value: "<< max_flow_test.maxFlow() << std::endl;
+  std::cout << "min cut value: "<< min_cut_value << std::endl;
+  std::cout << "min min cut value: "<< min_min_cut_value << std::endl;
+  std::cout << "max min cut value: "<< max_min_cut_value << 
+    std::endl<< std::endl;
+
+  
+  return 0;
+}
Index: src/work/jacint/preflow_hl4.h
===================================================================
--- src/work/jacint/preflow_hl4.h	(revision 105)
+++ src/work/jacint/preflow_hl4.h	(revision 109)
@@ -1,38 +1,48 @@
 // -*- C++ -*-
 /*
-preflow_hl4.h
+preflow_h5.h
 by jacint. 
-Runs the two phase highest label preflow push algorithm. In phase 0
-we maintain in a list the nodes in level i < n, and we maintain a 
-bound k on the max level i < n containing a node, so we can do
-the gap heuristic fast. Phase 1 is the same. (The algorithm is the 
-same as preflow.hl3, the only diff is that here we use the gap
-heuristic with the list of the nodes on level i, and not a bfs form the
-upgraded node.)
-
-In phase 1 we shift everything downwards by n.
-
-Member functions:
-
-void run() : runs the algorithm
-
- The following functions should be used after run() was already run.
-
-T maxflow() : returns the value of a maximum flow
-
-T flowonedge(EdgeIt e) : for a fixed maximum flow x it returns x(e) 
-
-FlowMap allflow() : returns a maximum flow
-
-void allflow(FlowMap& _flow ) : returns a maximum flow
-
-void mincut(CutMap& M) : sets M to the characteristic vector of a 
-     minimum cut. M should be a map of bools initialized to false.
-
-void min_mincut(CutMap& M) : sets M to the characteristic vector of the 
+Heuristics: 
+ 2 phase
+ gap
+ list 'level_list' on the nodes on level i implemented by hand
+ highest label
+ relevel: in phase 0, after BFS*n relabels, it runs a reverse 
+   bfs from t in the res graph to relevel the nodes reachable from t.
+   BFS is initialized to 20
+
+Due to the last heuristic, this algorithm is quite fast on very 
+sparse graphs, but relatively bad on even the dense graphs.
+
+'NodeMap<bool> cut' is a member, in this way we can count it fast, after
+the algorithm was run.
+
+The constructor runs the algorithm.
+
+Members:
+
+T maxFlow() : returns the value of a maximum flow
+
+T flowOnEdge(EdgeIt e) : for a fixed maximum flow x it returns x(e) 
+
+FlowMap Flow() : returns the fixed maximum flow x
+
+void Flow(FlowMap& _flow ) : returns the fixed maximum flow x
+
+void minMinCut(CutMap& M) : sets M to the characteristic vector of the 
      minimum min cut. M should be a map of bools initialized to false.
 
-void max_mincut(CutMap& M) : sets M to the characteristic vector of the 
+void maxMinCut(CutMap& M) : sets M to the characteristic vector of the 
      maximum min cut. M should be a map of bools initialized to false.
+
+void minCut(CutMap& M) : fast function, sets M to the characteristic 
+     vector of a minimum cut. 
+
+Different member from the other preflow_hl-s (here we have a member 
+'NodeMap<bool> cut').
+
+CutMap minCut() : fast function, giving the characteristic 
+     vector of a minimum cut.
+
 
 */
@@ -41,7 +51,10 @@
 #define PREFLOW_HL4_H
 
+#define BFS 20
+
 #include <vector>
-#include <stack>
 #include <queue>
+
+#include <time_measure.h>  //for test
 
 namespace hugo {
@@ -49,4 +62,5 @@
   template <typename Graph, typename T, 
     typename FlowMap=typename Graph::EdgeMap<T>, 
+    typename CutMap=typename Graph::NodeMap<bool>,
     typename CapMap=typename Graph::EdgeMap<T> >
   class preflow_hl4 {
@@ -63,16 +77,19 @@
     FlowMap flow;
     CapMap& capacity;  
+    CutMap cut;
     T value;
     
   public:
 
+    double time;
+
     preflow_hl4(Graph& _G, NodeIt _s, NodeIt _t, CapMap& _capacity) :
-      G(_G), s(_s), t(_t), flow(_G, 0), capacity(_capacity) { }
-
-
-    void run() {
- 
-      bool phase=0;
+      G(_G), s(_s), t(_t), flow(_G, 0), capacity(_capacity), 
+      cut(G, false) {
+
+      bool phase=0;   //phase 0 is the 1st phase, phase 1 is the 2nd
       int n=G.nodeNum(); 
+      int relabel=0;
+      int heur=(int)BFS*n;
       int k=n-2;
       int b=k;
@@ -84,5 +101,7 @@
       typename Graph::NodeMap<int> level(G,n);      
       typename Graph::NodeMap<T> excess(G); 
-      std::vector<std::stack<NodeIt> > stack(n);    
+      
+      std::vector<NodeIt> active(n);
+      typename Graph::NodeMap<NodeIt> next(G);
       //Stack of the active nodes in level i < n.
       //We use it in both phases.
@@ -108,5 +127,5 @@
 	for(InEdgeIt e=G.template first<InEdgeIt>(v); e.valid(); ++e) {
 	  NodeIt w=G.tail(e);
-	  if ( level.get(w) == n ) {
+	  if ( level.get(w) == n && w !=s ) {
 	    bfs_queue.push(w);
 	    NodeIt first=level_list[l];
@@ -129,5 +148,8 @@
 	  NodeIt w=G.head(e);
 	  if ( level.get(w) < n ) {	  
-	    if ( excess.get(w) == 0 && w!=t ) stack[level.get(w)].push(w); 
+	    if ( excess.get(w) == 0 && w!=t ) {
+	      next.set(w,active[level.get(w)]);
+	      active[level.get(w)]=w;
+	    }
 	    flow.set(e, c); 
 	    excess.set(w, excess.get(w)+c);
@@ -152,4 +174,11 @@
 	  */
 	  phase=1;
+	  
+	  //Now have a min cut.
+	  for( EachNodeIt v=G.template first<EachNodeIt>(); 
+	       v.valid(); ++v) 
+	    if (level.get(v) >= n ) cut.set(v,true);
+	  
+	  time=currTime();
 	  level.set(s,0);
 	  std::queue<NodeIt> bfs_queue;
@@ -168,5 +197,8 @@
 		bfs_queue.push(u);
 		level.set(u, l);
-		if ( excess.get(u) > 0 ) stack[l].push(u);
+		if ( excess.get(u) > 0 ) {
+		    next.set(u,active[l]);
+		    active[l]=u;
+		}
 	      }
 	    }
@@ -178,5 +210,8 @@
 		bfs_queue.push(u);
 		level.set(u, l);
-		if ( excess.get(u) > 0 ) stack[l].push(u);
+		if ( excess.get(u) > 0 ) {
+		    next.set(u,active[l]);
+		    active[l]=u;
+		}
 	      }
 	    }
@@ -186,12 +221,12 @@
 
 
-	if ( stack[b].empty() ) --b;
+	if ( active[b] == 0 ) --b;
 	else {
 	  
-	  NodeIt w=stack[b].top();        //w is a highest label active node.
-	  stack[b].pop();           
+	  NodeIt w=active[b];
+	  active[b]=next.get(w);
 	  int lev=level.get(w);
 	  T exc=excess.get(w);
-	  int newlevel=n;          //In newlevel we bound the next level of w.
+	  int newlevel=n;          //bound on the next level of w.
 	  
 	  for(OutEdgeIt e=G.template first<OutEdgeIt>(w); e.valid(); ++e) {
@@ -204,7 +239,9 @@
 	      /*Push is allowed now*/
 	      
-	      if ( excess.get(v)==0 && v!=t && v!=s ) 
-		stack[level.get(v)].push(v); 
-	      /*v becomes active.*/
+	      if ( excess.get(v)==0 && v!=t && v!=s )  {
+		int lev_v=level.get(v);
+		next.set(v,active[lev_v]);
+		active[lev_v]=v;
+	      }
 	      
 	      T cap=capacity.get(e);
@@ -244,7 +281,9 @@
 	      /*Push is allowed now*/
 	      
-	      if ( excess.get(v)==0 && v!=t && v!=s ) 
-		stack[level.get(v)].push(v); 
-	      /*v becomes active.*/
+	      if ( excess.get(v)==0 && v!=t && v!=s ) {
+		int lev_v=level.get(v);
+		next.set(v,active[lev_v]);
+		active[lev_v]=v;
+	      }
 	      
 	      T flo=flow.get(e);
@@ -282,5 +321,6 @@
 	  if ( phase ) {
 	    level.set(w,++newlevel);
-	    stack[newlevel].push(w);
+	    next.set(w,active[newlevel]);
+	    active[newlevel]=w;
 	    b=newlevel;
 	  } else {
@@ -304,4 +344,5 @@
 	      } 
 	    }
+	    //unlacing ends
 		
 
@@ -329,5 +370,6 @@
 		
 		level.set(w,++newlevel);
-		stack[newlevel].push(w);
+		next.set(w,active[newlevel]);
+		active[newlevel]=w;
 		b=newlevel;
 		if ( k < newlevel ) ++k;
@@ -339,7 +381,76 @@
 	      }
 	    }
+
+	    ++relabel;
+	    if ( relabel >= heur ) {
+	      relabel=0;
+	      b=n-2;
+	      k=b;
+		
+	      for ( int i=1; i!=n; ++i ) { 
+		active[i]=0;
+		level_list[i]=0;
+	      }
+
+	      //bfs from t in the res graph to relevel the nodes
+	      for( EachNodeIt v=G.template first<EachNodeIt>(); 
+		   v.valid(); ++v) level.set(v,n);
+
+	      level.set(t,0);
+	      std::queue<NodeIt> bfs_queue;
+	      bfs_queue.push(t);
+	      
+	      while (!bfs_queue.empty()) {
+		
+		NodeIt v=bfs_queue.front();	
+		bfs_queue.pop();
+		int l=level.get(v)+1;
+		
+		for(InEdgeIt e=G.template first<InEdgeIt>(v); 
+		    e.valid(); ++e) {
+		  if ( capacity.get(e) == flow.get(e) ) continue;
+		  NodeIt u=G.tail(e);
+		  if ( level.get(u) == n ) { 
+		    bfs_queue.push(u);
+		    level.set(u, l);
+		    if ( excess.get(u) > 0 ) {
+		      next.set(u,active[l]);
+		      active[l]=u;
+		    }
+		    NodeIt first=level_list[l];
+		    if ( first != 0 ) left.set(first,w);
+		    right.set(w,first);
+		    left.set(w,0);
+		    level_list[l]=w;
+		  }
+		}
+		
+		
+		for(OutEdgeIt e=G.template first<OutEdgeIt>(v); 
+		    e.valid(); ++e) {
+		  if ( 0 == flow.get(e) ) continue;
+		  NodeIt u=G.head(e);
+		  if ( level.get(u) == n ) { 
+		    bfs_queue.push(u);
+		    level.set(u, l);
+		    if ( excess.get(u) > 0 ) {
+		      next.set(u,active[l]);
+		      active[l]=u;
+		    }
+		    NodeIt first=level_list[l];
+		    if ( first != 0 ) left.set(first,w);
+		    right.set(w,first);
+		    left.set(w,0);
+		    level_list[l]=w;
+		  }
+		}
+	      }
+	      
+	      level.set(s,n);
+	    }
+	  
 	  } //phase 0
 	} // if ( exc > 0 )
- 
+	
 	
 	} // if stack[b] is nonempty
@@ -362,5 +473,5 @@
      */
 
-    T maxflow() {
+    T maxFlow() {
       return value;
     }
@@ -372,5 +483,5 @@
     */
 
-    T flowonedge(EdgeIt e) {
+    T flowOnEdge(EdgeIt e) {
       return flow.get(e);
     }
@@ -378,5 +489,5 @@
 
 
-    FlowMap allflow() {
+    FlowMap Flow() {
       return flow;
     }
@@ -384,5 +495,5 @@
 
     
-    void allflow(FlowMap& _flow ) {
+    void Flow(FlowMap& _flow ) {
       for(EachNodeIt v=G.template first<EachNodeIt>() ; v.valid(); ++v)
 	_flow.set(v,flow.get(v));
@@ -395,6 +506,6 @@
     */
     
-    template<typename CutMap>
-    void mincut(CutMap& M) {
+    template<typename _CutMap>
+    void minMinCut(_CutMap& M) {
     
       std::queue<NodeIt> queue;
@@ -434,6 +545,6 @@
     */
     
-    template<typename CutMap>
-    void max_mincut(CutMap& M) {
+    template<typename _CutMap>
+    void maxMinCut(_CutMap& M) {
     
       std::queue<NodeIt> queue;
@@ -470,14 +581,19 @@
 
 
-
-    template<typename CutMap>
-    void min_mincut(CutMap& M) {
-      mincut(M);
-    }
-
+    template<typename _CutMap>
+    void minCut(_CutMap& M) {
+      for( EachNodeIt v=G.template first<EachNodeIt>(); 
+	   v.valid(); ++v) 
+	M.set(v, cut.get(v));
+    }
+
+   
+    CutMap minCut() {
+      return cut;
+    }
 
 
   };
-}//namespace hugo
+}//namespace marci
 #endif 
 
Index: src/work/jacint/preflow_max_flow.cc
===================================================================
--- src/work/jacint/preflow_max_flow.cc	(revision 109)
+++ src/work/jacint/preflow_max_flow.cc	(revision 109)
@@ -0,0 +1,40 @@
+#include <iostream>
+#include <fstream>
+
+#include <list_graph.hh>
+#include <dimacs.hh>
+#include <preflow_max_flow.h>
+#include <time_measure.h>
+
+using namespace hugo;
+
+// Use a DIMACS max flow file as stdin.
+// read_dimacs_demo < dimacs_max_flow_file
+int main(int, char **) {
+  typedef ListGraph::NodeIt NodeIt;
+  typedef ListGraph::EachEdgeIt EachEdgeIt;
+typedef ListGraph::EachNodeIt EachNodeIt;
+
+  ListGraph G;
+  NodeIt s, t;
+  ListGraph::EdgeMap<int> cap(G);
+  readDimacsMaxFlow(std::cin, G, s, t, cap);
+
+  std::cout << "preflow_max_flow demo ..." << std::endl;
+  
+  double pre_time=currTime();
+  preflow_max_flow<ListGraph, int> max_flow_test(G, s, t, cap);
+  ListGraph::NodeMap<bool> cut=max_flow_test.minCut();
+  double post_time=currTime();
+  
+  int cut_value=0;
+  for(EachEdgeIt e=G.first<EachEdgeIt>(); e.valid(); ++e) {
+    if (cut.get(G.tail(e)) && !cut.get(G.head(e))) cut_value+=cap.get(e);
+  }
+  
+  std::cout << "elapsed time: " << post_time-pre_time << " sec"<< std::endl; 
+  std::cout << "flow value: "<< max_flow_test.maxFlow() << std::endl;
+  std::cout << "cut value: "<< cut_value << std::endl;
+
+  return 0;
+}
